// Copyright 2002 Adam Megacz, see the COPYING file for licensing [LGPL]
package org.xwt.util;
import java.io.*;

/** easy to use logger */
public class Log {

    public static boolean on = true;
    public static boolean verbose = false;

    /** true iff nothing has yet been logged */
    public static boolean firstMessage = true;

    /** message can be a String or a Throwable */
    public static synchronized void log(Object o, Object message) {

        if (firstMessage) {
            firstMessage = false;
            System.err.println("===========================================================================");
            log(Log.class, "Logging enabled at " + new java.util.Date());
        }

        String classname;
        if (o instanceof Class) classname = ((Class)o).getName();
        else if (o instanceof String) classname = (String)o;
        else classname = o.getClass().getName();
        
        if (classname.indexOf('.') != -1) classname = classname.substring(classname.lastIndexOf('.') + 1);
        if (classname.length() > 20) classname = classname.substring(0, 20);
        while (classname.length() < 20) classname = " " + classname;
        classname = classname + ": ";

        if (!(message instanceof Throwable)) System.err.println(classname + message);
        else {
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            ((Throwable)message).printStackTrace(new PrintStream(baos));
            byte[] b = baos.toByteArray();
            BufferedReader br = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(b)));
            String s = null;
            try {
                while((s = br.readLine()) != null) {
                    System.err.print(classname);
                    for(int i=0; i<s.length(); i++)
                        System.err.print(s.charAt(i) == '\t' ? "    " : ("" + s.charAt(i)));
                    System.err.println();
                }
            } catch (Exception e) { }

        }
    }

}
